<!-------------------------------------------------------------------------------
 * Copyright (c) 2020 Contributors to the Eclipse Foundation
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 -------------------------------------------------------------------------------->

<ng-template #templateRef>
  {{ "settings.textBlocks.pickTextBlock" | translate }}
</ng-template>

<ng-container *ngIf="appFormGroup; else templateRef;">

  <div class="text-block--title">
    <label [for]="id">{{'textBlocks.textBlock' | translate}} {{appFormGroup?.value?.id}}</label>
  </div>

  <textarea #autoInsertTextField="appAutoInsertTextFieldToken"
            #textAreaElement
            (input)="appFormGroup?.get('text')?.patchValue(textAreaElement.value)"
            [disabled]="appFormGroup?.get('text')?.disabled"
            [id]="id"
            [value]="appFormGroup?.get('text')?.value"
            appAutoInsertTextFieldToken
            class="openk-textarea text-block--textarea">
  </textarea>

  <div
    *ngFor="let buttons of [appTextControlDefaultButtons, appTextControlReplacementButtons, appTextControlSelectButtons]"
    class="text-block--format">
    <button (click)="autoInsertTextField.insert(button.token, button.startToken, button?.requireLineBreak)"
            *ngFor="let button of buttons"
            [disabled]="appFormGroup.disabled"
            class="openk-button openk-chip text-block--format--chip">
      <span *ngIf="button.label" class="text-block--format--chip--label">
        {{button.label}}
      </span>
      <mat-icon *ngIf="button.icon"
                [class.text-block--format--chip--icon---rotate]="button.rotateIcon"
                class="text-block--format--chip--icon">
        {{button.icon}}
      </mat-icon>
    </button>
  </div>

  <div (cdkDropListDropped)="onDrop($event?.item?.data?.id, area)"
       (cdkDropListEntered)="onEnter($event?.item?.data?.id, area)"
       (cdkDropListExited)="onExit()"
       *ngFor="let area of dropAreaConfig; let i = index;"
       [cdkDropListEnterPredicate]="enterPredicate"
       [id]="area.elementId"
       cdkDropList class="drop-area openk-drag-list-with-hidden-placeholder">

    <div class="drop-area--title">
      {{area?.label | translate}}
    </div>

    <div class="drop--area--text-blocks">

      <button (click)="removeIdFromArea(id, area)"
              *ngFor="let id of appFormGroup.value | getRuleIdsOfTextBlock : area.key : area.type"
              [disabled]="appFormGroup?.disabled"
              class="openk-button openk-chip drop-area--button">
        <mat-icon class="drop-area--button--icon">clear</mat-icon>
        {{"textBlocks.textBlock" | translate }} {{id}}
      </button>

      <button *ngIf="area === selectedRule?.area" class="openk-button openk-chip drop-area--button"
              disabled>
        <mat-icon class="drop-area--button--icon">clear</mat-icon>
        {{"textBlocks.textBlock" | translate }} {{selectedRule?.id}}
      </button>
    </div>
  </div>

</ng-container>
